<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body onload="onPageLoading()">
    <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
        
        <table id="oder-table" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Order ID</th>
              <th>Kich co combo</th>
              <th>Loai pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
          </thead>
          <tbody>
            
          </tbody>
        </table>
      </div>
      <!--modal-->
      <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Oder Detal</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <div class="row">
                <div class="col-sm-12">
                <div class="form-group">
                    <label for="">Order Id</label>
                    <input type="text" class="form-control" id="inp-order-modal" >
                </div>
                <div class="form-group">
                    <label for="">Cỡ combol</label>
                    <input type="text" class="form-control" id="inp-combol-modal" >
                </div>
                <div class="form-group">
                    <label for="">Đường kính</label>
                    <input type="text" class="form-control" id="inp-duong-kinh-modal" >
                </div>
                <div class="form-group">
                    <label for="">Sường nướng (miếng)</label>
                    <input type="text" class="form-control" id="inp-suong-nuong-modal" >
                </div>
                <div class="form-group">
                    <label for="">Đồ uống</label>
                    <input type="text" class="form-control" id="inp-do-uong-modal">
                </div>
                <div class="form-group">
                    <label for="">Số lượng nước uống</label>
                    <input type="text" class="form-control" id="inp-so-luong-nuoc-uong-modal">
                </div>
                <div class="form-group">
                    <label for="">Voucher Id</label>
                    <input type="text" class="form-control" id="inp-voucher-modal">
                </div>
                <div class="form-group">
                    <label for="">Loại pizza</label>
                    <input type="text" class="form-control" id="inp-pizza-modal">
                </div>
                <div class="form-group">
                    <label for="">Salad (g)</label>
                    <input type="text" class="form-control" id="inp-salad-modal">
                </div>
                <div class="form-group">
                    <label for="">Thành tiền</label>
                    <input type="text" class="form-control" id="inp-thanh-tien-modal">
                </div>
                <div class="form-group">
                    <label for="">Giam giá</label>
                    <input type="text" class="form-control" id="inp-discount-modal">
                </div>
                <div class="form-group">
                    <label for="">Ho Tên</label>
                    <input type="text" class="form-control" id="inp-fullname-modal">
                </div>
                <div class="form-group">
                    <label for="">Số điện thoại</label>
                    <input type="text" class="form-control" id="inp-phone-modal">
                </div>
                <div class="form-group">
                    <label for="">Địa chỉ</label>
                    <input type="text" class="form-control" id="inp-address-modal">
                </div>
                <div class="form-group">
                    <label for="">Lời nhắn</label>
                    <input type="text" class="form-control" id="inp-message-modal">
                </div>
                <div class="form-group">
                    <label for="">Trạng thái đơn hàng</label>
                    <input type="text" class="form-control" id="inp-trang-thai-modal">
                </div>
                <div class="form-group">
                    <label for="">Ngày tạo đơn</label>
                    <input type="text" class="form-control" id="inp-ngay-tao-modal">
                </div>
                <div class="form-group">
                    <label for="">Ngày cập nhật</label>
                    <input type="text" class="form-control" id="inp-ngay-cap-nhat-modal">
                </div>
                </div>
            </div>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-danger" data-dismiss="modal" id="btn-cancel">Cancel</button>
              <button type="button" class="btn btn-warning" id="btn-confirm">Confirm</button>
            </div>
          </div>
        </div>
      </div>
</body>
<script>
    "use strict"
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gNameCol = ["id","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","action"];
    const gODER_ID_COl = 0;
    const gKICH_CO_COl = 1;
    const gLOAI_PIZZA_COl = 2;
    const gANUOC_UONG_COl = 3;
    const gTHANH_TIEN_COl = 4;
    const gHO_TEN_COl = 5;
    const gSDT_COl = 6;
    const gTRANG_THAI_COL = 7;
    const gACTION_COl = 8;
    var gOderList = [];
    var gIndex = null;
/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
$("#oder-table  ").on('click','.btn-detail',function()
{
    $("#exampleModal").modal("show");
})
$("#btn-confirm").on('click',function()
{   var vObjectRequest = {
            trangThai: "confirmed" 
        };
    onBtnUpdateClick(vObjectRequest);
})
$("#btn-cancel").on('click',function()
{
    var vObjectRequest = {
            trangThai: "cancel" 
        };
    onBtnUpdateClick(vObjectRequest);
})
$("#oder-table  ").on('click','td',function()
{
    gIndex = $(this).parent().index();
    console.log(gIndex);
    hienThiDataLenModal();
})
/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
function onPageLoading()
{
   
    $("#oder-table").DataTable({
        columns: [
          { data: gNameCol[gODER_ID_COl]},
          { data: gNameCol[gKICH_CO_COl]},
          { data: gNameCol[gLOAI_PIZZA_COl]},
          { data: gNameCol[gANUOC_UONG_COl]},
          { data: gNameCol[gTHANH_TIEN_COl]},
          { data: gNameCol[gHO_TEN_COl]},
          { data: gNameCol[gSDT_COl]},
          { data: gNameCol[gTRANG_THAI_COL]},
          { data: gNameCol[gACTION_COl]}
        ],
        columnDefs:[
          {
            targets: gACTION_COl,
            className: "text-center",
            defaultContent: " <button class='btn btn-primary btn-detail'>Chi tiết</button>"
          }
        ]
      });
      onBtnGetAllOrderClick();
}
/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //gọi mẫu lấy danh sách order
    function onBtnGetAllOrderClick()
    {
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
            type: 'GET',
            async: false,
            dataType: 'json',
            success(res)
            {    
                console.log(res);
                insertRowToTable(res);
                gOderList = res;
            },
            error()
            {
                console.log('Error get all oder');
            }
        })
    };
    // load data to table
    function insertRowToTable(paramOderList)
    {
    var vTable = $("#oder-table").DataTable();
    vTable.rows.add(paramOderList);
      vTable.draw();
    };
    // hàm ấn nút update
    function onBtnUpdateClick(paramTrangThai)
    {
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/orders/"+gOderList[gIndex].id,
            type: 'PUT',
            data: JSON.stringify(paramTrangThai),
            contentType:'application/json;charset=UTF-8',
            async: false,
            success: function() {
                alert("Update thành công!");       
            },
            error: function () {
                alert("Sửa đơn không thành công!");
            }
        })
    }
    function hienThiDataLenModal()
    {
        $("#inp-order-modal").val(gOderList[gIndex].id);
        $("#inp-combol-modal").val(gOderList[gIndex].kichCo);
        $("#inp-duong-kinh-modal").val(gOderList[gIndex].duongKinh);
        $("#inp-suong-nuong-modal").val(gOderList[gIndex].suon);
        $("#inp-do-uong-modal").val(gOderList[gIndex].idLoaiNuocUong);
        $("#inp-so-luong-nuoc-uong-modal").val(gOderList[gIndex].soLuongNuoc);
        $("#inp-voucher-modal").val(gOderList[gIndex].idVourcher);
        $("#inp-pizza-modal").val(gOderList[gIndex].loaiPizza);
        $("#inp-salad-modal").val(gOderList[gIndex].salad);
        $("#inp-thanh-tien-modal").val(gOderList[gIndex].thanhTien);
        $("#inp-discount-modal").val(gOderList[gIndex].giamGia);
        $("#inp-fullname-modal").val(gOderList[gIndex].hoTen);
        $("#inp-phone-modal").val(gOderList[gIndex].soDienThoai);
        $("#inp-address-modal").val(gOderList[gIndex].diaChi);
        $("#inp-message-modal").val(gOderList[gIndex].loiNhan);
        $("#inp-trang-thai-modal").val(gOderList[gIndex].trangThai);
        $("#inp-ngay-tao-modal").val(gOderList[gIndex].orderCode);
        $("#inp-ngay-cap-nhat-modal").val(gOderList[gIndex].ngayCapNhat);
    }
</script>
</html>